/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2003 Luca Saiu
Minor updates in 2006, by Luca Saiu.

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with epsilon; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */


#ifndef EAM_SET_H_
#define EAM_SET_H_

#include "types.h"

/* A data structure implementing a set of non-NULL void*'s */

typedef struct eam_set* set_t;

set_t eam_create_set(const integer_t size) __attribute__ (( malloc ));
void eam_destroy_set(set_t set);

void eam_insert_pointer_into_set(const void *pointer, set_t set);

/* Return 0 if the element was present, -1 otherwise: */
integer_t eam_remove_pointer_from_set(const void *pointer, set_t set);

integer_t eam_does_pointer_belong_to_set(const void *pointer, const set_t set)
  __attribute__ (( pure ));

/* Only useful for debugging (complexity is O(m)) */
void eam_dump_set(set_t s);

#endif /* #ifndef EAM_SET_H_ */
