/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


/* Just an experiment, to see whether #includ'ing all the GC sources in a
   single GCC compilation makes any difference in speed.
   With GCC 4.2 on GNU/Linux PowerPC the improvement is small, and using this
   technique clutters the Makefile too much (I could automatically generate
   Makefile.am with M4, so I could use macros... To do: try that)
   I think it might work better coupled with profile-driven feedback. To do:
   experiment with that. */

#include "gc.h"
#include "libraries/gc/homogeneous.h"
#include "libraries/gc/large.h"
#include "libraries/gc/generic_pools.h"
#include "libraries/gc/roots.h"
#include "libraries/gc/trace.h"
#include "libraries/gc/statistics.h"
#include "libraries/gc/heuristics.h"

#include "gc.c"
#include "libraries/gc/homogeneous.c"
#include "libraries/gc/large.c"
#include "libraries/gc/generic_pools.c"
#include "libraries/gc/roots.c"
#include "libraries/gc/trace.c"
#include "libraries/gc/statistics.c"
#include "libraries/gc/heuristics.c"
