#include <stdio.h>
#include "../common/types.h"
//#include "modules.h"
#include "runtime.h"
#include "modules.h"
//#include <readline/readline.h>
#include <gmp.h>

static struct eam_module *hello2;

char *eam_ehello_unmangled_name = "hello";
integer_t eam_ehello_globals_no = 4;

static integer_t integers[3] = { (integer_t)10, (integer_t)20, (integer_t)30};

word_t eam_ehello_global_1 = (word_t)123456789;
word_t eam_ehello_global_2 = (word_t)"abcd";
static word_t eam_ehello_global_3 = (word_t)(integer_t)123;
word_t eam_ehello_global_4 = (word_t)integers;

void eam_ehello_initialize(void){
  fprintf(stderr, "[Initializing hello]\n");
  /*
  fprintf(stderr, "> ");
  char *s = readline(NULL);
  clear_history();
  fprintf(stderr, "You wrote \"%s\".\n", s);
  if(s != NULL) free(s);
  fprintf(stderr, "Very good, we didn't crash yet.\n");
  */
  mpz_t  n;
  mpz_init (n);
  mpz_clear (n);

  hello2 = eam_load_module("hello2", "/home/luca/usr/lib/libhello2.la");
}

void eam_ehello_finalize(void){
  eam_unload_module(hello2);
  fprintf(stderr, "[Finalizing hello]\n");
}

integer_t eam_ehello_blocks_no = 3;

EAM_DECLARE_EXPORTED_BLOCK(eam_ehello_label_1);
EAM_DECLARE_INTERNAL_BLOCK(eam_ehello_label_2);
EAM_DECLARE_EXPORTED_BLOCK(eam_ehello_label_3);

EAM_BEGIN_EXPORTED_BLOCK(eam_ehello_label_1);
  fprintf(stderr, "[block 1 (exported) hello]\n");
  EAM_FAST_JUMP(eam_ehello_label_2);
EAM_END_BLOCK

EAM_BEGIN_INTERNAL_BLOCK(eam_ehello_label_2);
  fprintf(stderr, "[block 2 (internal) hello]\n");
  EAM_FAST_JUMP(eam_ehello_label_3);
EAM_END_BLOCK

EAM_BEGIN_EXPORTED_BLOCK(eam_ehello_label_3);
  fprintf(stderr, "[block 3 (exported) hello]\n");
  return NULL;
EAM_END_BLOCK
