/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2005 Luca Saiu
Updated in 2006 by Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


/* An header file just used to #include all the headers needed to compile 
   using the eAM runtime. */

#ifndef EAM_RUNTIME_RUNTIME_H_
#define EAM_RUNTIME_RUNTIME_H_

/* Some standard C library headers, more or less always needed: */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>

/* We always need the definition of basic eAM types such as word_t and 
   integer_t: */
#include "../common/types.h"

/* A useful macro to enable the user to access registers, both named and
   indexed, from C code within eAML files: */
#define EAM_REGISTER(r) \
  eam_register_ ## r

/* Declarations for eAM registers, including the ones implemented with
   physical machine registers: */
#include "registers.h"

/* Declaration of the eAM driver procedure: */
#include "driver.h"

/* The "pin-counting" macros: */
#include "pins.h"

/* Command line arguments are accessible from within the eAM: */
extern integer_t argc;
extern char **argv;

#endif // #ifndef EAM_RUNTIME_RUNTIME_H_
