/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#ifndef EAM_TRANSLATE_COMPILE_TIME_PARAMETERS_H_
#define EAM_TRANSLATE_COMPILE_TIME_PARAMETERS_H_

/* The size (in bytes of generated C code) of a set of compilation units. A set
   is made by adding compilation units until the total size is greater than or
   equal to this value: */
#define EAM_GENERATED_C_FILES_SET_SIZE 100000

/* The name of the compiler to be invoked at runtime, when compiling generated
   C code: */
#define EAM_CC "gcc-4.2"

/* The flags to give to EAM_CC when compiling generated C code. Note that
   sibling calls should *always* be optimized to prevent O(n) stack overhead
   in jumps, which implies that at least some optimization must always be
   enabled: */
#define EAM_CFLAGS "-O -Os --param max-completely-peeled-insns=1000000 --param max-completely-peel-times=1000000 --param max-peeled-insns=1000000 --param max-peel-times=1000000 --param max-unroll-times=1000000 --param max-unrolled-insns=1000000 -funroll-loops -fno-inline-functions"

#endif // #ifndef EAM_TRANSLATE_COMPILE_TIME_PARAMETERS_H_
