/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

#ifndef EAM_GENERATE_INCLUDING_C_H_
#define EAM_GENERATE_INCLUDING_C_H_

#include "../common/types.h"
#include "generate_c.h"

/* Generate a C file #including the other ones, allowing to compile all of
   them with a single compiler run, and allowing inter-compilation unit
   optimizations. This is expensive in terms of memory and CPU: */
void eam_generate_single_including_c_file(const struct eam_list *compilation_units,
                                          const char *temporary_directory);

/* Generate C files #including other generated C files, like
   generate_including_c_file(), but limiting the size of each set of files
   which are compiled (and optimized) together. The number of such sets is
   returned. The generated file names are <temporary_directory>/_i.c, where
   i is an index ranging from 0 to the returned number minus 1: */
integer_t eam_generate_including_c_files(const struct eam_list *compilation_units,
                                         const char *temporary_directory);

#endif // #ifndef EAM_GENERATE_INCLUDING_C_H_
