/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#include "../common/types.h"
#include "../common/common_text.h"
#include "../common/command_line.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <limits.h>


int main(int argc, char** argv){
  /* Define command line behavior: */
  eam_set_program_name ("eam-mangle (" PACKAGE_NAME ")");
  eam_set_general_help_message("Print the given identifier in mangled form");
  eam_set_synopsis_string ("eam-mangle [OPTIONS] identifier");
  eam_set_version_string (VERSION_STRING);
  eam_set_copyright_string (COPYRIGHT_STRING);
  eam_set_license_message (LICENSE_STRING);
  eam_set_bug_reporting_message (BUG_REPORTING_MESSAGE);
  
  /* Parse command-line and check its correctness: */
  eam_parse_command_line(&argc, argv);
  
  if(argc != 2)
    eam_command_line_fatal("there must be exactly one parameter");
  
  /* Print the mangled form of the only argument*/
  printf("%s\n", eam_mangle(argv[1]));
  
  return EXIT_SUCCESS;
} /* main */
